var FormWithInitials = new Class({
    initialize:function(formClass, fieldClass, userChangesClass){
        this.userChangesClass = userChangesClass;
        this.fields = new Array();
        this.values = {};
        $$('.' + fieldClass).each(function(field, index){
            field.addEvent('focus', this.focusHandler.bind(this));
            field.addEvent('blur', this.blurHandler.bind(this));
            field.addEvent('keypress', this.keydown.bind(this));
            field.addEvent('change', this.keydown.bind(this));
            this.values[field.id] = field.title;
            if (field.title != field.value)
                field.addClass(this.userChangesClass)
            this.fields.include(field);
        }.bind(this));
        $$('.'+formClass).each(function(form, index){
            this.initForm(form);
        }.bind(this));
    },

    focusHandler:function(e){
        var e = new Event(e);e.preventDefault();
        if (!e.target.hasClass(this.userChangesClass)) {
            if (e.target.value == this.values[e.target.id]){
                e.target.value = "";
            };
        };
    },

    blurHandler:function(e){
        var e = new Event(e);
        if (e.target.value == ""){
            e.target.value = this.values[e.target.id];
            if (e.target.hasClass(this.userChangesClass))
                e.target.removeClass(this.userChangesClass);
        };
    },

    keydown:function(e){
        var e = new Event(e);
        if (!e.target.hasClass(this.userChangesClass))
            e.target.addClass(this.userChangesClass);
    },

    initForm:function(formEl){
        if (formEl) {
            formEl.addEvent('submit', function(e){
                if (e && e.stop)
                  e.stop();
                this.fields.each(function(field, index){
                    if (!field.hasClass(this.userChangesClass)){
                        field.value = "";
                    }
                }.bind(this));
                formEl.submit();
            }.bind(this));
            return formEl;
        };
        return null;
    }

});


window.addEvent('domready', function(){
    var magicForm = new FormWithInitials('FormWithInitials', 'FieldInitial', 'UserInput');
});
