var Tabs = new Class({

  Implements: [Options],

  options: {
    hiding_class: 'hidden'
  },
  _events: {},

  initialize: function(options) {
    var tabs = this;
    this.setOptions(options);
    this.knobs = $$(this.options.knob_selector);
    this._events._knob_click = function(e){
      e.stop();
      tabs.switchTab(this);
    }
    this.knobs.addEvent('click', this._events._knob_click);
  },

  switchTab: function(knob){
    if (!knob.hasClass('selected')) {
      var content_id = knob.getAttribute('id').substring(4);
      $$(this.options.content_selector).addClass(this.options.hiding_class);
      $(content_id).removeClass(this.options.hiding_class);
      $$(this.options.knob_selector).removeClass('selected');
      knob.addClass('selected');
    }
  },

  detach: function(){
    this.knobs.removeEvent('click', this._events._knob_click)
  }


});

